/*==============================================================================
   DEMO.C :- RTF Code Generator Demo Program
   Sub Systems, Inc.
   Software License Agreement  (1998)
   ----------------------------------
   This is a demo program.  The program shows how you can utilize HTML-RTF Converter
   to convert between HTML and RTF formats.
===============================================================================*/
#define  STRICT

#include "windows.h"
#if defined (_WIN32)
   #if !defined(WIN32)
     #define WIN32
   #endif
#endif
#if !defined(WIN32)
  #include "print.h"
  #if defined (__TURBOC__)
    typedef unsigned short USHORT;     // missing in compiler
  #endif
#endif

#include "stdio.h"
#include "stdlib.h"
#include "fcntl.h"
#include "sys\types.h"
#include "sys\stat.h"
#include "io.h"
#include "string.h"
#include "math.h"

#include "commdlg.h"

/******************************************************************************
    WIN32 specific defines
*******************************************************************************/
#undef  huge
#define huge
#undef  FreeProcInstance
#define FreeProcInstance(x)
#define GET_WM_COMMAND_ID(wp,lp) LOWORD(wp)
#define NOTIFY_MSG(wp,lp)        HIWORD(wp)
#define farmalloc  malloc
#define farrealloc realloc
#define farfree    free

#define true       TRUE
#define false      FALSE
#define null       NULL

#include "pdc.h"

#include "demo.h"

/****************************************************************************
   Main Windows Routine
****************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
    MSG msg;
    int i;

    #ifndef WIN32
      int QueueLength=96;
      while (!SetMessageQueue(QueueLength) && (QueueLength-=8));
    #endif

    SetMessageQueue(96);   // needed for OLE2

    lpDemoDlg = MakeProcInstance((FARPROC)DemoDlg, hInst);


    DialogBoxParam(hInstance,"DemoDlg",NULL,(DLGPROC)lpDemoDlg,0);

    FreeProcInstance((FARPROC)lpDemoDlg);       // free the dialog box

    return 0;//(msg.wParam);
}

/****************************************************************************
    DemoDlg:
    Display the dialog box.
****************************************************************************/
int FAR PASCAL _export DemoDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
    BYTE InFile[300],OutFile[300];
    int  i,flag;
    DWORD_PTR id;
    BOOL  result=false;

    switch (message) {
        case WM_INITDIALOG:
            hDemoWnd=hDlg;

            // initialize the radion button
            SendDlgItemMessage(hDlg,IDC_HTML_TO_RTF,BM_SETCHECK,1,0L);

            lstrcpy(OutFile,"test.pdf");
            SetDlgItemText(hDlg,IDC_OUTPUT_FILE,OutFile);

            return (FALSE);

        case WM_COMMAND:
            switch (GET_WM_COMMAND_ID(wParam,lParam)) {
                case IDC_PURCHASE:
                   ShellExecute(hDlg,"open","http://www.subsystems.com/pdw.htm",NULL,NULL,0);

                   break;

                case IDOK:
                   SetDlgItemText(hDlg,IDC_STATUS,"");

                   GetDlgItemText(hDlg,IDC_OUTPUT_FILE,OutFile,sizeof(OutFile)-1);

                   // check the file names
                   if (lstrlen(OutFile)==0) {
                      MessageBeep(0);
                      SetFocus(GetDlgItem(hDlg,IDC_OUTPUT_FILE));
                      return true;
                   }

                   SetDlgItemText(hDlg,IDC_STATUS,"Generating...");

                   // do the conversion
                   id=PdcStartDoc("",OutFile,"Mike","Sub Systems, Inc","PDF Generation Test","PDF Generation Test","test,subsys",
                                  "12/31/2014","12/31/2014",0);

                   //id=PdcStartDoc("",OutFile,"Mike","Sub Systems, Inc","PDF Generation Test","PDF Generation Test","test,subsys",
                   //               "12/31/2014","12/31/2014",PDFFLAG_PDFA);

                   //id=PdcStartDoc("",OutFile,"Mike","Sub Systems, Inc","PDF Generation Test","PDF Generation Test","test,subsys",
                   //               "12/31/2014","12/31/2014",PDFFLAG_PDFA3);

                   //id=PdcStartDoc2("",OutFile,"Mike","Sub Systems, Inc","PDF Generation Test","PDF Generation Test","test,subsys",
                   //               "12/31/2004","12/31/2004",0,PERM_MOD|PERM_PRINT|PERM_COPY,"abc","efg");  // an example of creating PDF doc with security permissions and password protection

                   if (false) {   // 20230315: test of passing unicode meta data
                      WORD name[10];
                      name[0]=0x3045;
                      name[1]=0x3041;
                      name[2]=0x3042;
                      name[3]=0x3043;
                      name[4]=0x3044;
                      name[5]=0;
                      id=PdcStartDocU2("",L"test.pdf",name,L"Sub Systems, Inc",L"PDF Generation Test",L"PDF Generation Test",L"test,subsys",
                                  "12/31/2004","12/31/2004",PDFFLAG_PDFA3,PERM_MOD|PERM_PRINT|PERM_COPY,"","","");  // an example of creating PDF doc with security permissions and password protection
                   }


                   if (id>0) {
                      //PdcEmbedFile(id,"test.xml",null,0,"test xml file");  // example of embedding an external file in pdf
                      //PdcEmbedFile(id,"test.png",null,0,"test png file");  // example of embedding an external file in pdf

                      PrintPage1(id);  // print some text on the page

                      //DemoTest1(id);
                      //DemoTest2(id);
                      //DemoTest3(id);
                      //DemoTest4(id);
                      //DemoDrawEmf(id,"test.emf");  // create pdf from a metafile
                      result=PdcEndDoc(id);
                   }

                   SetDlgItemText(hDlg,IDC_STATUS,result?"Done!":"Error!");
                   if (result) ShellExecute(hDlg,"open",OutFile,NULL,NULL,SW_SHOW);


                   break;

                case IDCANCEL:
                   EndDialog(hDlg, FALSE);
                   ProcessMsg=FALSE;
                   return (TRUE);
                default:
                   ;
            }
            break;
    }
    return (FALSE);
}

////////////////////////////////////////////////////////////////////////////////////////////////////////////
///////////// Helper functions
////////////////////////////////////////////////////////////////////////////////////////////////////////////
/******************************************************************************
    PrintPage1:
    An example of printing on a page being generated
******************************************************************************/
PrintPage1(DWORD_PTR DocId)
{
   HDC hDC;
   int ResX,ResY,PageWidth,PageHeight;
   LPBYTE pText;
   HFONT hMedFont,hSmallFont,hBigFont,hMedBoldFont,hPrevFont;
   LOGFONT lFont;

   int UNITS_PER_INCH;

   PageWidth=8.5*1440;    // assume a letter size paper - paper size specified in twips units
   PageHeight=11*1440;

   // start the page
   if (NULL==(hDC=PdcStartPage(DocId,PageWidth,PageHeight))) {
      MessageBox(NULL,"Error starting a new page","Error",MB_OK);
      return false;
   }

   // Set mapping from our units (twips) to device units
   ResX=GetDeviceCaps(hDC,LOGPIXELSX);
   ResY=GetDeviceCaps(hDC,LOGPIXELSY);


   UNITS_PER_INCH=1440;     // draw in twips units (1440 twips = 1 inch) - you can use any units

   SetMapMode(hDC,MM_ANISOTROPIC);
   SetWindowOrgEx(hDC,0,0,NULL);   // set the logical window origin
   SetViewportOrgEx(hDC,0,0,NULL); // set view port origins

   SetWindowExtEx(hDC,UNITS_PER_INCH,UNITS_PER_INCH,NULL); // our units
   SetViewportExtEx(hDC,ResX,ResY,NULL); // equivalent device dimension

   // draw on the page using the device context returned by the PdcStartPage function
   // create some fonts for text drawing
   memset(&lFont,0,sizeof(LOGFONT));
   lFont.lfHeight=-(10*UNITS_PER_INCH)/72;    // 10 points font
   lFont.lfOutPrecision=OUT_DEFAULT_PRECIS;
   lFont.lfClipPrecision= CLIP_DEFAULT_PRECIS;
   lFont.lfQuality=DRAFT_QUALITY;
   lstrcpy(lFont.lfFaceName,"Times New Roman");  // "Times New Roman");

   hSmallFont=CreateFontIndirect(&lFont);

   lFont.lfHeight=-(12*UNITS_PER_INCH)/72;    // 12 points font
   hMedFont=CreateFontIndirect(&lFont);

   lFont.lfHeight=-(12*UNITS_PER_INCH)/72;    // 12 points font
   lFont.lfWeight=700;
   hMedBoldFont=CreateFontIndirect(&lFont);

   lFont.lfHeight=-(14*UNITS_PER_INCH)/72;    // 14 points font
   hBigFont=CreateFontIndirect(&lFont);


   // write title text
   hPrevFont=SelectObject(hDC,hBigFont);
   SetTextColor(hDC,0xFF);      // write in red
   pText="S T A T E M E N T";
   TextOut(hDC,5000,1500,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore


   // Write customer name between two horizontal lines
   SelectObject(hDC,GetStockObject(BLACK_PEN));
   MoveToEx(hDC,2000,2900,NULL);
   LineTo(hDC,10000,2900);

   hPrevFont=SelectObject(hDC,hMedFont);
   SetTextColor(hDC,0xFF0000);      // write in red
   pText="Customer Name: ";
   TextOut(hDC,2000,3000,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore

   hPrevFont=SelectObject(hDC,hMedBoldFont);
   pText="Affront Dog Collars";
   TextOut(hDC,3800,3000,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore

   MoveToEx(hDC,2000,3400,NULL);
   LineTo(hDC,10000,3400);


   // Write balance figures

   hPrevFont=SelectObject(hDC,hMedFont);
   SetTextColor(hDC,0x000000);      // write in black
   pText="Previous Balance: $2000.00";
   TextOut(hDC,7000,5000,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore

   hPrevFont=SelectObject(hDC,hMedFont);
   pText="Current Balance:  $1000.00";
   TextOut(hDC,7000,5500,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore

   MoveToEx(hDC,8800,6000,NULL);
   LineTo(hDC,9800,6000);

   hPrevFont=SelectObject(hDC,hMedBoldFont);
   pText="Due:  $3000.00";
   TextOut(hDC,8200,6100,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore

   MoveToEx(hDC,8800,6500,NULL);
   LineTo(hDC,9800,6500);
   MoveToEx(hDC,8800,6530,NULL);
   LineTo(hDC,9800,6530);

   MoveToEx(hDC,7000,7000,NULL);
   LineTo(hDC,9800,7000);

   //PrintSignature(hDC,hBigFont,4000,8000);  // an example of printing a signature

   // write some page footer text
   MoveToEx(hDC,2000,14000,NULL);
   LineTo(hDC,10000,14000);

   hPrevFont=SelectObject(hDC,hSmallFont);
   SetTextColor(hDC,0x00FF00);      // write in green
   pText="Sub Systems, Inc.";
   TextOut(hDC,5000,14000,pText,strlen(pText));
   pText="3017 Covington Place, Round Rock, TX 78681";
   TextOut(hDC,4000,14200,pText,strlen(pText));
   SelectObject(hDC,hPrevFont);   // restore


   // an example of ArcTo
   //MoveToEx(hDC,1000,1000,NULL);
   //ArcTo(hDC, 2000, 8000, 3000, 9000, 2500, 8000, 3000, 8500);
   //LineTo(hDC,5000,5000);


   END:

   // end the page
   if (!PdcEndPage(DocId)) {
      MessageBox(NULL,"Error finishing a page","Error",MB_OK);
      return false;
   }

   // delete resources
   DeleteObject(hSmallFont);
   DeleteObject(hMedFont);
   DeleteObject(hMedBoldFont);
   DeleteObject(hBigFont);
   return true;
}

/******************************************************************************
    PrintSignature:
    An example of adding signature
******************************************************************************/
PrintSignature(HDC hDC,HFONT hFont, int x, int y)
{
    struct StrPdfField fld;
    HFONT hPrevFont;
    LPBYTE pText;


    // start signature block
    memset(&fld,0,sizeof(fld));

    fld.sign[0]='F';
    fld.sign[1]='L';
    fld.begin=true;
    fld.page=0;
    fld.x=x/20;   // pass in point units
    fld.y=y/20;   // pass in point units
    fld.width=72*3;   // pass in point units
    fld.height=72*1 ;   // pass in point units
    fld.type=PDFFIELD_SIGNATURE;
    lstrcpyW(fld.CertName,L"Sub Systems, Inc.");     // certificate name
    lstrcpy(fld.DateTime,"D:20130710085500-05'00'");     // date/time in D:YYYYMMDDhhmmss-hh'mm' format where the last -hh'mm' is +- from gmt time
    GdiComment(hDC,sizeof(fld),(LPBYTE)&fld);


    SetTextColor(hDC,0xff);
    hPrevFont=SelectObject(hDC,hFont);
    pText="Signed: my signature";
    x+=1440/4;
    y+=1440/4;
    TextOut(hDC,x,y,pText,strlen(pText));
    pText="Date: 7/10/2013";
    y+=1440/3;
    TextOut(hDC,x,y,pText,strlen(pText));
    SelectObject(hDC,hPrevFont);   // restore

    // end signature block
    memset(&fld,0,sizeof(fld));

    fld.sign[0]='F';
    fld.sign[1]='L';
    fld.begin=false;
    GdiComment(hDC,sizeof(fld),(LPBYTE)&fld);

    return true;
}

/******************************************************************************
    DemoTest1:
    Test code
******************************************************************************/
void DemoTest1(int id)
{
    int pageWidth=(85*144);
    int pageHeight=(110*144);
    HDC hDC;
    HFONT hFont,hOldFont;
    HBRUSH hOldBr;
    BYTE text[100]="Hello ygj";
    int UNITS_PER_INCH,ResX,ResY;
    XFORM xm;

    hDC = PdcStartPage(id, pageWidth, pageHeight);

    // Set mapping from our units (twips) to device units
    ResX=GetDeviceCaps(hDC,LOGPIXELSX);
    ResY=GetDeviceCaps(hDC,LOGPIXELSY);

    UNITS_PER_INCH=1440;     // draw in twips units (1440 twips = 1 inch) - you can use any units

    SetMapMode(hDC,MM_ANISOTROPIC);
    SetWindowOrgEx(hDC,0,0,NULL);   // set the logical window origin
    SetViewportOrgEx(hDC,0,0,NULL); // set view port origins
    SetWindowExtEx(hDC,UNITS_PER_INCH,UNITS_PER_INCH,NULL); // our units
    SetViewportExtEx(hDC,ResX,ResY,NULL); // equivalent device dimension

    //SetMapMode(hDC,MM_TWIPS);

    //memset(&xm,0,sizeof(xm));
    //xm.eM11=2;
    //xm.eM22=-2;
    //SetWorldTransform(hDC,&xm);

    //GetWorldTransform(hDC,&xm);


    hFont=CreateFont(480,         // 480, nHeight - 24*20
       0,                         // nWidth
       2700,                       // nEscapement  - 45 degree angle
       0,                      // nOrientation in 1/10 degrees
       FW_NORMAL,                 // nWeight
       FALSE,                     // bItalic
       FALSE,                     // bUnderline
       0,                         // cStrikeOut
       ANSI_CHARSET,              // nCharSet
       OUT_DEFAULT_PRECIS,        // nOutPrecision
       CLIP_DEFAULT_PRECIS,       // nClipPrecision
       DEFAULT_QUALITY,           // nQuality
       DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
       "Arial");

    hOldFont = SelectObject(hDC,hFont);
    SetBkColor(hDC,0xff);

    TextOut(hDC,2000, 5000, text,strlen(text));

    //MoveToEx(hDC,2000,5000,NULL);
    //LineTo(hDC,4000,5000);   // this line should display above the text.

    //TextOut(hDC,2000, -5000, text,strlen(text));
    //MoveToEx(hDC,2000,-5000,NULL);
    //LineTo(hDC,4000,-5000);   // this line should display above the text.

    //TextOut(hDC,100, 100, text,strlen(text));
    //MoveToEx(hDC,100,10,NULL);
    //LineTo(hDC,400,50);   // this line should display above the text.

    SelectObject(hDC,hOldFont);

    // draw a Chord
    hOldBr=SelectObject(hDC,GetStockObject(GRAY_BRUSH));
    Chord(hDC,1400,1400,5*1440,5*1440,3*1440,3*1440, 3*1440,2*1400);
    SelectObject(hDC,hOldBr);

    PdcEndPage(id);
}

/******************************************************************************
    DemoTest2:
    Test code
******************************************************************************/
void DemoTest2(int id)
{
    int pageWidth=(85*144);
    int pageHeight=(110*144);
    HDC hDC;
    int oldMapMode,oldGMode;


    hDC = PdcStartPage(id, pageWidth, pageHeight);

    oldMapMode = SetMapMode( hDC, MM_LOMETRIC  );
    oldGMode = SetGraphicsMode( hDC, GM_ADVANCED );

    drawFigureAt( hDC, 300, -300, 0 );
    drawFigureAt( hDC, 900, -300, 45 );
    drawFigureAt( hDC, 300, -900, 270 );
    drawFigureAt( hDC, 900, -900, 180 );

    SetGraphicsMode( hDC, oldGMode );
    SetMapMode( hDC, oldMapMode );

    MoveToEx(hDC,2000,5000,NULL);
    LineTo(hDC,4000,5000);   // this line should display above the text.


    PdcEndPage(id);

    //toPrinter();       // send a copy to printer
}

void drawFigure( HDC i_dc )
{
    RECT bounds;
    HFONT arial;
    HGDIOBJ oldFont;

    bounds.left = -300;
    bounds.right = 300;
    bounds.bottom = 200;
    bounds.top = -200;

    Rectangle( i_dc, bounds.left, bounds.top, bounds.right, bounds.bottom );

    arial = CreateFont( 100, 0, 0, 0, FW_NORMAL, FALSE, FALSE, FALSE, ANSI_CHARSET, OUT_TT_PRECIS, CLIP_DEFAULT_PRECIS, PROOF_QUALITY, FF_SWISS,  "Arial");

    oldFont =  SelectObject( i_dc, arial );

    SetTextAlign( i_dc, TA_LEFT | TA_TOP | TA_NOUPDATECP );

    DrawText( i_dc, "Hello There", 11, &bounds,  DT_CENTER | DT_VCENTER | DT_SINGLELINE );

    SelectObject( i_dc, oldFont );
    DeleteObject( arial );
}

void drawFigureAt( HDC i_dc, int i_xCenter, int i_yCenter, double i_rotAngDeg )
{

    // Apply Rotation
    double rotAngRad = ( i_rotAngDeg / 180.0 ) * 3.14159265; // Convert to Radians
    double CosVal,SinVal;

    XFORM xform;


    xform.eDx = 0;
    xform.eDy = 0;


    SinVal=sin( rotAngRad );
    CosVal=cos( rotAngRad );

    xform.eM11 = CosVal;
    xform.eM12 = SinVal;
    xform.eM21 = -SinVal;
    xform.eM22 = CosVal;


    SetWorldTransform( i_dc, &xform );

    // Offset to Position

    xform.eM11 = 1;
    xform.eM22 = 1;
    xform.eM12 = 0;
    xform.eM21 = 0;

    xform.eDx = ( i_xCenter );
    xform.eDy = ( i_yCenter);

    ModifyWorldTransform( i_dc, &xform, MWT_RIGHTMULTIPLY );

    drawFigure( i_dc );

}

void toPrinter()
{
 PRINTDLG dlgParams;

 memset( &dlgParams, 0, sizeof( dlgParams ) );

 dlgParams.lStructSize = sizeof( dlgParams );
 dlgParams.Flags = PD_RETURNDC ;


 if( PrintDlg( &dlgParams ) )
 {
  DOCINFO docInfo;
  memset(&docInfo, 0, sizeof( docInfo ) );
  docInfo.cbSize = sizeof(docInfo);
  docInfo.lpszDocName = "Rotation Test";

  StartDoc( dlgParams.hDC, &docInfo );
  StartPage( dlgParams.hDC );

  drawPage( dlgParams.hDC );

  EndPage( dlgParams.hDC );
  EndDoc( dlgParams.hDC );
 }

 DeleteDC(dlgParams.hDC);
    GlobalFree(dlgParams.hDevMode);
    GlobalFree(dlgParams.hDevNames);
}

void drawPage( HDC i_dc )
{
 int oldMapMode = SetMapMode( i_dc, MM_LOMETRIC  );
 int oldGMode = SetGraphicsMode( i_dc, GM_ADVANCED );

 drawFigureAt( i_dc, 300, -300, 0 );
 drawFigureAt( i_dc, 900, -300, 45 );
 drawFigureAt( i_dc, 300, -900, 270 );
 drawFigureAt( i_dc, 900, -900, 180 );

 SetGraphicsMode( i_dc, oldGMode );
 SetMapMode( i_dc, oldMapMode );
}

/******************************************************************************
    DemoTest3:
    Test code
******************************************************************************/
void DemoTest3(int id)
{
    int pageWidth=(85*144);
    int pageHeight=(110*144);
    HDC hDC;
    HFONT hFont,hOldFont;
    BYTE text[100]="Hello";
    int UNITS_PER_INCH,ResX,ResY;

    hDC = PdcStartPage(id, pageWidth, pageHeight);

    // Set mapping from our units (twips) to device units
    ResX=GetDeviceCaps(hDC,LOGPIXELSX);
    ResY=GetDeviceCaps(hDC,LOGPIXELSY);

    UNITS_PER_INCH=1440;     // draw in twips units (1440 twips = 1 inch) - you can use any units

    SetMapMode(hDC,MM_ANISOTROPIC);
    SetWindowOrgEx(hDC,0,0,NULL);   // set the logical window origin
    SetViewportOrgEx(hDC,0,0,NULL); // set view port origins
    SetWindowExtEx(hDC,UNITS_PER_INCH,UNITS_PER_INCH,NULL); // our units
    SetViewportExtEx(hDC,ResX,ResY,NULL); // equivalent device dimension

    hFont=CreateFont(480,         // 480, nHeight - 24*20
       0,                         // nWidth
       0,                         // nEscapement  - 45 degree angle
       0,                         // nOrientation
       FW_NORMAL,                 // nWeight
       FALSE,                     // bItalic
       FALSE,                     // bUnderline
       0,                         // cStrikeOut
       ANSI_CHARSET,              // nCharSet
       OUT_DEFAULT_PRECIS,        // nOutPrecision
       CLIP_DEFAULT_PRECIS,       // nClipPrecision
       DEFAULT_QUALITY,           // nQuality
       DEFAULT_PITCH | FF_SWISS,  // nPitchAndFamily
       "Arial");

    hOldFont = SelectObject(hDC,hFont);
    TextOut(hDC,2000, 5000, text,strlen(text));

    SelectObject(hDC,hOldFont);

    PdcEndPage(id);
}

/******************************************************************************
    DemoTest4:
    Test code
******************************************************************************/
void DemoTest4(int id)
{
    int pageWidth=(85*144);
       int pageHeight=(110*144);
       HDC hDC;
       HPEN hFont,hOldFont;
       BYTE text[100]="Hello";
       int UNITS_PER_INCH,ResX,ResY;

    RECT rectText, rectControl;
    POINT ptTextCenter;
    int iCornersY = 5;
    POINT m_ptCorners;
    RECT topLeftCorner, bottomLeftCorner, bottomRightCorner, upperRightCorner;
    POINT ptULStart, ptBLStart, ptBRStart, ptURStart;
    POINT ptULEnd, ptBLEnd, ptBREnd, ptUREnd;

    UNITS_PER_INCH=1440;     // draw in twips units (1440 twips = 1 inch) - you can use any units

       hDC = PdcStartPage(id, pageWidth, pageHeight);

       // Set mapping from our units (twips) to device units
       ResX=GetDeviceCaps(hDC,LOGPIXELSX);
       ResY=GetDeviceCaps(hDC,LOGPIXELSY);

    SetMapMode(hDC,MM_ANISOTROPIC);

    rectText.left = 52;
    rectText.top = 10;
    rectText.right = 111;
    rectText.bottom = 23;

    ptTextCenter.x = 81;
    ptTextCenter.y = 16;

    rectControl.left = 46;
    rectControl.top = 10;
    rectControl.right = 136;
    rectControl.bottom = 75;

    m_ptCorners.x = 5;
    m_ptCorners.y = 5;

       UNITS_PER_INCH=1440;     // draw in twips units (1440 twips = 1 inch) - you can use any units

     hFont=CreatePen(PS_SOLID, 1, 0xAAFFAA);

       hOldFont = SelectObject(hDC,hFont);

    MoveToEx(hDC, rectText.left, ptTextCenter.y, NULL );

    // TOP LEFT CORNER
    topLeftCorner.left = rectControl.left;
    topLeftCorner.top = ptTextCenter.y;
    topLeftCorner.right = rectControl.left + (m_ptCorners.x * 2);
    topLeftCorner.bottom = ptTextCenter.y + (iCornersY * 2);
    ptULStart.x = rectControl.left + m_ptCorners.x;
    ptULStart.y = ptTextCenter.y;
    ptULEnd.x = rectControl.left;
    ptULEnd.y = ptTextCenter.y + iCornersY;

    ArcTo(hDC, topLeftCorner.left, topLeftCorner.top, topLeftCorner.right, topLeftCorner.bottom, ptULStart.x, ptULStart.y, ptULEnd.x, ptULEnd.y );

    // BOTTOM LEFT CORNER
    bottomLeftCorner.left = rectControl.left;
    bottomLeftCorner.top = rectControl.bottom - (iCornersY * 2);
    bottomLeftCorner.right = rectControl.left + (m_ptCorners.x * 2);
    bottomLeftCorner.bottom = rectControl.bottom;
    ptBLStart.x = rectControl.left;
    ptBLStart.y = rectControl.bottom - iCornersY;
    ptBLEnd.x = rectControl.left + m_ptCorners.x;
    ptBLEnd.y = rectControl.bottom;

    ArcTo(hDC, bottomLeftCorner.left, bottomLeftCorner.top, bottomLeftCorner.right, bottomLeftCorner.bottom, ptBLStart.x, ptBLStart.y, ptBLEnd.x, ptBLEnd.y );

    // BOTTOM RIGHT CORNER
    bottomRightCorner.left = rectControl.right - (m_ptCorners.x * 2);
    bottomRightCorner.top = rectControl.bottom - (iCornersY * 2);
    bottomRightCorner.right = rectControl.right;
    bottomRightCorner.bottom = rectControl.bottom;
    ptBRStart.x = rectControl.right - m_ptCorners.x;
    ptBRStart.y = rectControl.bottom;
    ptBREnd.x =  rectControl.right;
    ptBREnd.y = rectControl.bottom - iCornersY;

    ArcTo(hDC, bottomRightCorner.left, bottomRightCorner.top, bottomRightCorner.right, bottomRightCorner.bottom, ptBRStart.x, ptBRStart.y, ptBREnd.x, ptBREnd.y );

    // UPPER RIGHT CORNER
    upperRightCorner.left = rectControl.right - (m_ptCorners.x * 2);
    upperRightCorner.top =  ptTextCenter.y;
    upperRightCorner.right = rectControl.right;
    upperRightCorner.bottom = ptTextCenter.y + (iCornersY * 2);
    ptURStart.x = rectControl.right;
    ptURStart.y = ptTextCenter.y + iCornersY;
    ptUREnd.x =  rectControl.right - m_ptCorners.x;
    ptUREnd.y = ptTextCenter.y;

    ArcTo(hDC, upperRightCorner.left, upperRightCorner.top, upperRightCorner.right, upperRightCorner.bottom, ptURStart.x, ptURStart.y, ptUREnd.x, ptUREnd.y );


    // END - right edge of text
    LineTo(hDC, rectText.right, ptTextCenter.y );

    hOldFont = SelectObject(hDC,hFont);

       SelectObject(hDC,hOldFont);

       PdcEndPage(id);
}

/******************************************************************************
    DemoDrawEmf:
    Test code to draw an emf
******************************************************************************/
void DemoDrawEmf(int id, LPBYTE EmfFile)
{
    int pageWidth=(85*144);
    int pageHeight=(110*144);
    HDC hDC;
    int UNITS_PER_INCH,ResX,ResY,size;
    HENHMETAFILE hMeta;
    ENHMETAHEADER hdr;
    RECT rect;

    UNITS_PER_INCH=1440;     // draw in twips units (1440 twips = 1 inch) - you can use any units

    hDC = PdcStartPage(id, pageWidth, pageHeight);

    // Set mapping from our units (twips) to device units
    ResX=GetDeviceCaps(hDC,LOGPIXELSX);
    ResY=GetDeviceCaps(hDC,LOGPIXELSY);

    SetMapMode(hDC,MM_ANISOTROPIC);
    SetWindowOrgEx(hDC,0,0,NULL);   // set the logical window origin
    SetViewportOrgEx(hDC,0,0,NULL); // set view port origins

    SetWindowExtEx(hDC,UNITS_PER_INCH,UNITS_PER_INCH,NULL); // our units
    SetViewportExtEx(hDC,ResX,ResY,NULL); // equivalent device dimension

    // load and the metafile and play it
    hMeta = GetEnhMetaFile(EmfFile);
    if (hMeta==null) {
       MessageBox(null,"Could not create the metafile dc",EmfFile,MB_OK);
       return;
    }
    size=GetEnhMetaFileHeader(hMeta,sizeof(hdr),&hdr);

    rect.left=rect.top=UNITS_PER_INCH;  // build the rectangle in the logical unit to draw to
    rect.right=rect.left+(hdr.rclFrame.right-hdr.rclFrame.left)*UNITS_PER_INCH/2540;
    rect.bottom=rect.top+(hdr.rclFrame.bottom-hdr.rclFrame.top)*UNITS_PER_INCH/2540;

    PlayEnhMetaFile(hDC,hMeta,&rect);

    DeleteEnhMetaFile(hMeta);

    PdcEndPage(id);
}


/******************************************************************************
    OurPrintf:
    This routine formats and display a given set of arguments.  The format
    is given by the first argument.  The argument 2 to n contain the
    arguments for the specified format.  The function uses MessageBox to
    display the formatted string.
******************************************************************************/
int OurPrintf(LPSTR fmt,...)
{
    LPSTR ArgStart;
    char string[300];
    HWND hWnd;

    ArgStart=(LPSTR) &fmt;  // pointer to first argument
    ArgStart=&ArgStart[4];  // go past the first argument
    wvsprintf(string,fmt,ArgStart);

    if (NULL!=(hWnd=FindWindow("DBWin",NULL))) { // debug window open
        if (NULL!=(hWnd=GetWindow(hWnd,GW_CHILD))) {    // get the edit window
           int len=lstrlen(string);
           string[len]=0xd;
           string[len+1]=0xa;
           string[len+2]=0;
           #if defined (WIN32)
              SendMessage(hWnd,EM_SETSEL,32767,32767);  // show the last line
              SendMessage(hWnd,EM_REPLACESEL,0,(DWORD)(LPSTR)string);
              SendMessage(hWnd,EM_SCROLLCARET,0,0);     // scroll caret into view
           #else
              SendMessage(hWnd,EM_SETSEL,0,MAKELPARAM(32767,32767));  // show the last line
              SendMessage(hWnd,EM_REPLACESEL,0,(DWORD)(LPSTR)string);
              SendMessage(hWnd,EM_SETSEL,0,MAKELPARAM(32767,32767));  // show the last line
           #endif
        }
    }
    else MessageBox(NULL,string,NULL,MB_OK);
    return TRUE;
}


